(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenC_back_types.sml,v
   Comment: Structure of code generated by C codgens
   Release: scope-0-15_final 

     Copyright (C) 2001-2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   CodGenC_back_types.sml,v 1.3 2003/07/22 22:00:48 wasowski Exp 
*)

structure CodGenC_back_types = struct 

(* some interface *)

open CodGen

(* values assigned to bytecode markers *)

val STMRK_val = 0
val HMRK_val  = 1
val IMRK_val  = 2

(* code generated system *)

type csystem = { 

	name	    :string,		(* symbolic name of the system(needed)*)
	fname       :string,		(* symbolic name of source file       *)
	codgen      :string,		(* name of the code generator         *)
	lrmnemonics :codgen,		(* #defines introducing LR mnemonics  *)
	
	hor         :codgen,		(* compiled or-states hierarchy       *)
	hand	    :codgen,		(* compiled and-states hierarchy      *)

	hor_dict    :codgen option,	(* optional indirection for hor       *)
	hand_dict   :codgen option,	(* optional indirection for hand      *)
	or_syms     :codgen option,	(* state names to ids in debug mode   *)
	and_syms    :codgen option,     (* state names to ids in debug mode   *)
	hor_acc     :codgen,		(* macro for accessing hor            *)
	hand_acc    :codgen,		(* macro for accessing hand           *)

	symbol      :codgen option,     (* entry in symbolic dicts (debug)    *)

	trans       :codgen,		(* transitions array		      *)
	init        :codgen,		(* system initialization (if needed)  *)
	tranidx     :codgen,		(* dictionary of transition lists     *)
	
	evmacros    :codgen,		(* event names macro definitions      *)
	evdict      :codgen option,	(* debug mode: symbolic event names   *)
	evtypes     :codgen,		(* structures for events	      *)
	evunion     :codgen,		(* union of structures for current ev *)

	vardefs	    :codgen,		(* generated variable definitions     *)
	vardecls    :codgen,		(* external variable declarations     *)
	consts      :codgen,		(* #define's for model constants      *)

	actions     :codgen,		(* actions dispatcher                 *)
	guards	    :codgen option,	(* guards dispatcher                  *)
	externhdr   :codgen,		(* prototypes for external functions  *)
	signals     :codgen option,	(* list of triggering parts of acts   *)
	history     :codgen,		(* history controlling information    *)

	ROOT_STATE  :codgen,		(* andstref-erence to topmost state   *)
	STATE_WIDTH :codgen,		(* bound of state configuration size  *)
	TGT_WIDTH   :codgen,		(* bound for targets number in a scope*)
	EVENTNO     :codgen,		(* number of events (aka not-an-event)*)
	queue       :codgen,		(* signal queue control macros & array*)

	UNMANGLE_PCNC 
		    :codgen,		(* macro accessing pos/neg conds count*)
	UNMANGLE_ACGD
		    :codgen,		(* macro accessing action/guard refs  *)

	GET_OR	    :codgen,		(* macro: given orstref return pointer*)
	GET_AND     :codgen,		(* macro: given andstref ret pointer  *)
	GET_ENTER   :codgen,		(* macro: get enter action for state s*)
	GET_EXIT    :codgen,		(* macro: get exit  action for state s*)
	SCOPE_GUARDS:codgen,		(* macro: define if model uses guards *)
	SCOPE_SLIST :codgen,		(* macro: def if model uses sig lists *)
	SCOPE_CONFSET			(* macro: def if using implementation *)
		    :codgen,		(*        of state conf based on list *)
	exitmode    :codgen,		(* macro: PURE_EXIT, IMPURE_EXIT      *)

	markers     :codgen,		(* macro definitons for LR markers    *)

	prev_conf   :codgen,		(* previous sate configuration        *)
	next_conf   :codgen,		(* new (being computed) configuration *)
	targets     :codgen,		(* pool of targets notyet activated   *)
	
	actionref   :codgen,		(* inferred type of action refs       *)
	guardref    :codgen,		(* inferred type of guard ref type    *)
	orstref     :codgen,		(* inferred type of orstate refs      *)
	andstref    :codgen,		(* inferred type of andstate refs     *)
	signalref   :codgen,		(* inferred return type for all acts  *)
	eventtag    :codgen,		(* inferred type for signals/events   *)
	tranref     :codgen,		(* inferred (here..) type for tranrefs*)
	traniter    :codgen,		(* type of iterators over trans,      *)
					(* sometimes greater than tranref     *)
	conf	    :codgen,		(* type of configuartions             *)
	confiter    :codgen,		(* for iterators over configurations  *)
	tgtsiter    :codgen,		(* for iterators over target sets     *)
	queueiter   :codgen option,	(* for iterators over queues          *)
	types       :codgen		(* model-independent types(simplicity)*)

	(* TODO: we miss access macros for enex, pcnc and acgd !!! *)

}

end
