/* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenVS_smokedrv.c,v
   Comment: Tiny driver used for code generation to be linked with VS models 
            (visualSTATE compatible mode)
   Release: scope-0-15_final 

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   CodGenVS_smokedrv.c,v 1.6 2003/04/24 21:24:58 wasowski Exp
*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <SEMTypes.h>
#include <SEMLibB.h>

void init (int argc) {
		
	if ( argc > 3 ) {

		printf ("init,");
		fflush(stdout);
	}
	SEM_Init(); 
}
	
	
int main(int argc, const char * argv[])
{
	SEM_ACTION_EXPRESSION_TYPE ActionExpressNo;
	SEM_EVENT_TYPE EventNo = SE_RESET;
	int i = 0;
	int j = 0;
	unsigned max1 = atoi (argv[1]);
	unsigned max2 = atoi (argv[2]) +1;


	printf ("Smoke test. Events %d. Limit %d. Number of tries %d...\n", EVENTNO, max2, max1);
	
	srand(time(NULL));
	init( argc );

#ifdef SCOPE_SIGNALQUEUE
	SEM_InitSignalQueue();
#endif /* SCOPE_SIGNALQUEUE */

	SEM_Deduct( SE_RESET ); /* != SES_OKAY ) break; */

	for (; i < max1; ++i) {

		if (rand() % 100 == 0)
			init( argc );
			
		j = rand();

		EventNo = (SEM_EVENT_TYPE) (j % max2);

		SEM_Deduct( EventNo ); /* != SES_OKAY ) break; */
	
		
		if ( argc > 3 ) {
			printf ("%d,", EventNo);
			fflush(stdout);
		}

		while (SEM_GetOutput(&ActionExpressNo) == SES_FOUND)
			SEM_Action( ActionExpressNo );

		if (SEM_NextState() != SES_OKAY) {

			printf("ERROR\n");
			break;
		}
	}

	printf ("done\n");

	return 0;

}
		

