(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tInterpr.sml,v
   Comment: Test script for Interpr module
   Release: scope-0-15_final

     Copyright (C) 2001-2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   tInterpr.sml,v 1.15 2003/07/24 12:52:34 wasowski Exp
*)
  
app load ["Haskellish", "Say", "Test", "tInterprLang", "parse", 
          "VsrAbsyn","PP","Interpr", "Simplifier"];

use "PPSymbol.sml";

open Haskellish Test tInterprLang Say Interpr;
        
(* fixities - Haskellish *)	    
infixr 0 $;

(* fixities - tInterprLang *)

infix  6 OUT;
infix  6 STATE;
infixr 5 INITIAL;
infixr 5 ||;
infixr 4 RESTART;
infixr 4 CONTINUE;
infixr 3 STEPS;
infixr 2 NEXT;

(* testcases *)

use "tInterprCases.sml";

(* initialise *)

val testname = "Interpr";
val _ = Test.init testname;

(* fname must be a vsr or vsp filename *)

(* NOTE: Apparently outputs are not tested at all! *)

type aor = unit
type atr = unit

  fun teststep (sys : (aor,atr) system,
		{input,endconf,outputs} :stepspec,
		mglobal0 :mglobal) :mglobal =
	let 
		val mglobal1 = step sys input mglobal0
			       handle e => intErr e 200302184
		val c = map (Symbol.name o nameand) 
				(ANDStateSet.listItems (#1 mglobal0))
		val _ = case endconf of
			  SOME c => (tstassert $ conf_agrees(SOME c,#1 mglobal1)
				     handle e => (print "BAD CONFIGURATION!"; 
						  raise e))
			| NONE   => tstassert $ conf_agrees(SOME c,#1 mglobal1)
	in mglobal1 end 


  fun teststeps (model :(aor,atr) model) (step :step, mglobals :mglobal list) 
							:mglobal list =
	case step of
		  CONT sl => map3 teststep (model,sl,mglobals)
		| INIT sl => map init model before  (* YUCK! innefficient *)
			     map3 teststep (model,sl,mglobals)



  fun testf ({file,iniconf,steps} : testcase) :bool =  
	let val model	  = Simplifier.simplify_model $ VsrAbsyn.translate $
					parse.parse file NONE
	    val mglobals1 = map init model handle e => intErr e 200302183
	    val _ = tstassert $ ListPair.all (fn (ini,mg)=>conf_agrees(ini,#1 mg)) 
					$ (map #1 iniconf,mglobals1) 
	(* FIXME: above -> actions issued during init are not tested, even
		  if available in test language now *)
	    val mglobals2 = foldl (teststeps model) mglobals1 steps
	in true end handle TestFailed => false 


  
  val res = map (fn t => test testf t ("  " ^ #file t)) testcases
		handle e => exnhandler e (fn ()=> [false]);

  val _ = Test.finalise testname res
