(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/trans-sig.sml,v
   Comment: Signature of model transformations.
   Release: scope-0-15_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   trans-sig.sml,v 1.3 2003/07/08 15:45:01 wasowski Exp
*)

signature TRANS = sig

	type options
	type aor
	type atr

	val apply: options -> string -> (aor,atr) Absyn.model 
					-> (aor,atr) Absyn.model		
end

(* 
	[options] type of options which can be passed to given model
	transformer.

	[apply opts fname m] returns a transformation of m, where opts
	are options directing transformation and fname is the source file
	name of the model
*)
